//Georg Kuschk - B und Vkompr.Uebg1
#include <afx.h>
#include <math.h>


#define	HEADER_OFFSET	15


//berechnet die Selbstinformation eines Ereignisses der Wkeit p
double inf(double p)
{
	return -(log(p)/log(2));	//zur LogarithmusBasis 2
}


unsigned char *LoadPGM(char *filename , long int &size)
{
	CFile	file;
	CFileException	e;
	long int	fsize;
	long int	BytesRead;
	unsigned char		*buf;

	if (!file.Open(filename,CFile::modeRead, &e))
	{
		printf("Could not open File %s !",filename);
		return NULL;
	}
	else
	{
		fsize = file.GetLength();
		if (fsize <= 0)
			return NULL;

		buf = new unsigned char[fsize];
		//buf = (char *)malloc(fsize);

		BytesRead = file.Read(buf,fsize);
		file.Close();
	}

	size = BytesRead;
	return buf;
}








int main(int argc, char* argv[])
{
	unsigned char	*buf;
	long int size;

	double	ptable[257];
	double	uebergaenge[257][257];
	long int	anz_uebergaenge =0;
	double	entropie=0;
	double	entropie_markov=0;

	char	filename[200];
	long int i,j;


	for (i=0; i<255; i++)
		ptable[i]=0;

	for (i=0; i<255; i++)
	{
		for (j=0; i<255; i++)
		{
			uebergaenge[i][j]=0;
		}
	}


	printf("\nDateiname : ");
	scanf("%s",&filename);
	buf = LoadPGM(filename , size);

	if (buf != NULL)
	{
		printf("%d Bytes read", size);

		//Pixelfolge durchlaufen und dabei
		//Wahrscheinlichkeitstabelle aufstellen und
		//Uebergangswahrscheinlichkeiten des MarkovModells berechnen
		for (i=HEADER_OFFSET+1; i<size-1; i++)
		{
			ptable[buf[i]] = ptable[buf[i]] +1;
			if (i>HEADER_OFFSET+1)
			{
				uebergaenge[buf[i-1]][buf[i]] = uebergaenge[buf[i-1]][buf[i]] +1;
			}
		}

		for (i=0; i<255; i++)
			ptable[i] = ptable[i]/(size-HEADER_OFFSET);

		for (i=0; i<255; i++)
		{
			for (j=0; j<255; j++)
			{
				if (uebergaenge[j][i] > 0)
				{
					uebergaenge[j][i] = uebergaenge[j][i] / (double)(size-HEADER_OFFSET-1);
					anz_uebergaenge++;
				}
			}
		}

		//Markov-Modell 1.Ordnung
		//Zustandswahrscheinlichkeiten ausgeben
		//nicht vorkommende Pixel werden auch nicht ausgegeben
		int anz = 0;
		printf("\nZustandswahrscheinlichkeiten :");
		for (i=0; i<255; i++)
		{
			if (ptable[i]>0)
			{
				printf("\nWert %d hat Zustandswahrscheinlichkeit %f",i,ptable[i]);
				anz++;
			}
		}
		printf("\n\nMarkov-Modell 1.Ordnung :",anz);
		printf("\nVon 256 moeglichen Zustaenden sind %d erreichbar.",anz);
		printf("\nAnzahl der verschiedenen auftretenden Zustandsuebergaenge = %d",anz_uebergaenge);

		//Entropie beim Markov-Modell :
		double	h_i , w;
		for (i=0; i<255; i++)
		{
			h_i=0;
			w=0;
			if (ptable[i]>0)
			{
				for (j=0; j<255; j++)
				{
					//alle in zustand i eingehenden uebergaenge betrachten :
					if ( (uebergaenge[j][i] > 0) && (i != j) )
						h_i = h_i + uebergaenge[j][i]*inf(uebergaenge[j][i]);
						w = w + uebergaenge[j][i];
				}

				h_i = h_i + (1-w)*inf(1-w);
				entropie_markov = entropie_markov + ptable[i]*h_i;
			}
		}


		printf("\n\nEntropie bei Verwendung des Markov-Modells 1.Ordnung : %f",entropie_markov);


		//Entropie fuer unterstellte Unabhaengigkeit berechnen (Basis 2)
		for (i=0; i<255; i++)
			if (ptable[i]>0)
				entropie = entropie +ptable[i]*inf(ptable[i]);
		printf("\n\nEntropie bei unterstellter Unabhaengigkeit der Pixel = %f",entropie);

	}
	else
	{
		printf("Reading Error !");
	}



	getchar();
	getchar();
	return 0;
}

